/*
 * off.c -- power off a Sony gracefully
 *
 * Author: Jyrki Kuoppala (jkp@cs.hut.fi)
 *
 * $Header$
 * 
 * A friendly shutdown program for Sony NEWS workstations
 * This is supposed to be the login shell of a special account `off'
 * This programs checks if it's on console, and if it is it performs
 * a graceful shutdown in three minutes by executing /etc/shutdown -x +3
 *
 * This program is in the public domain
 *
 * Created: Tue Sep  5 17:26:53 1989
 * Last modified: Wed Sep  6 23:43:40 1989
 */

#include <stdio.h>
#include <errno.h>
#include <strings.h>

extern char *ttyname(), *fprintf(), *printf();
extern int getppid(), execl(), perror(), exit();

int
main()
{
  char answer[3];
  if (strcmp (ttyname (0),  "/dev/console")) {
    (void) fprintf (stderr, "Not on system console\n");
    exit (-1);
  }
  (void) printf ("This command will power off the system in three minutes.\n");
  (void) printf ("It's supposed to be used when the machine is to be moved\n");
  (void) printf ("and whenever the machine needs to be powered down.\n");
  (void) printf ("It is NOT supposed to be done when you log off the system.\n");
  (void) printf ("Are you sure you want to do this (y/n) ? ");
  if (fgets (answer, 1, stdin) == NULL || *answer != 'y')
    exit (-2);
  if (execl ("/etc/shutdown", "shutdown", "-x", SHUTDOWN_TIME, 0) < 0) {
    (void) perror ("off: exec of /etc/shutdown failed, something is wrong ;-<");
    exit (4);
  }
  return (0);
}
